#ifndef _NET8814_DEVICE_
#define _NET8814_DEVICE_

#include "windows.h"

// #################### ԻͶ #####################
// Humanized data types definition
#ifndef _HUMAN_DATA_TYPE_
#define _HUMAN_DATA_TYPE_
typedef char				I8;		// 8λз
typedef unsigned char		U8;		// 8λ޷
typedef short				I16;	// 16λз
typedef unsigned short		U16;	// 16λ޷
typedef long				I32;	// 32λз
typedef unsigned long		U32;	// 32λ޷
typedef __int64				I64;	// 64λз
typedef unsigned __int64	U64;	// 64λ޷
typedef float				F32;	// 32λ(,ͬΪlabVIEWеSGL)
typedef double				F64;	// 64λ(˫,ͬΪlabVIEWеDBL)
#endif // _HUMAN_DATA_TYPE_

// ########################## 豸ָ ########################
#define NET8814_AI_MAX_CHANNELS		8	// ֧8·ģͨ
#define NET8814_AI_DATA_WIDTH		4	// AIݿ(ֽ)
#define NET8814_AI_SAMP_RANGE_CNT	4	// AI̵λ


//////////////////////////////////////////////////////////
// 豸Ϣ
#ifndef _DEVICE_NET_INFO_
#define _DEVICE_NET_INFO_

typedef struct _DEVICE_NET_INFO_A
{
	char    strIP[16];					// IPַ, L"192.168.2.70"
	char	strSubnetMask[16];			// , L"255.255.255.255"
	char	strGateway[16];				// , L"192.168.2.1"
	char	strMAC[20];					// ַ,  "00-01-02-03-04-05",ûһ㲻޸
} DEVICE_NET_INFOA, *PDEVICE_NET_INFOA;

typedef struct _DEVICE_NET_INFO_W
{
	wchar_t strIP[16];					// IPַ, L"192.168.2.70"
	wchar_t strSubnetMask[16];			// , L"255.255.255.255"
	wchar_t strGateway[16];				// , L"192.168.2.1"
	wchar_t strMAC[20];					// ַ,  "00-01-02-03-04-05",ûһ㲻޸
} DEVICE_NET_INFOW, *PDEVICE_NET_INFOW;

#ifndef _UNICODE
typedef DEVICE_NET_INFOA DEVICE_NET_INFO, *PDEVICE_NET_INFO;
#else
typedef DEVICE_NET_INFOW DEVICE_NET_INFO, *PDEVICE_NET_INFO;
#endif

#endif

//-----------------------------------

// ############# AIṹNET8814_AI_PARAM #############
typedef struct _NET8814_AI_CH_PARAM // AIͨṹ
{
	U32 bChannelEn;			// ͨʹ,1:ʹ 0:ʹ
	U32 nSampleRange;		// Χ(Sample Range)λѡ, 泣(˲ڵЧ,δעĲڵģʽЧ)
	U32 nRefGround;			// زοʽ()
	U32 nCoupling;			// Ϸʽ
	U32 bIEPEEn;			// ɵѹʹ(Integrated Electronics Piezo Electric Enable), ĬΪֹ

	U32 nReserved0;			// (δ)
	U32 nReserved1;			// (δ)
	U32 nReserved2;			// (δ)
} NET8814_AI_CH_PARAM, *PNET8814_AI_CH_PARAM;

// AIӲṹNET8814_AI_CH_PARAMеnSampleRangeʹõĲΧλѡ
#define NET8814_AI_SAMPRANGE_N11_P11V			0 // 11V
#define NET8814_AI_SAMPRANGE_N5D5_P5D5V			1 // 5.5V
#define NET8814_AI_SAMPRANGE_N2D2_P2D2V			2 // 2.2V
#define NET8814_AI_SAMPRANGE_N1D1_P1D1V			3 // 1.1V

// AIӲͨṹNET8814_AI_CH_PARAMеnRefGroundʹõĵزοѡ
#define NET8814_AI_REFGND_DIFF		0 // (Differential)()
#define NET8814_AI_REFGND_PDIFF		1 // α(Pseudo-Diff)()˿ֻ֧α

// AIӲͨṹNET8814_AI_CH_PARAMеnCouplingʹõϷʽѡ
#define NET8814_AI_CPLG_DC			0 // ֱ
#define NET8814_AI_CPLG_AC			1 // 

typedef struct _NET8814_AI_START_TRIG // ʼ
{
	U32 nTriggerType;		//  
	U32 nTriggerSource;		// Դ, ʹģػģⴰʱ: 0=ͨеһ; ʹֱشʱ: 1-9=RTSI0-RTSI8
	U32 nTriggerDir;	    // ִ(Digital Trigger Direction)
	F32 fTriggerLevelTop;	// (شƽ),λ:(V)
	F32 fTriggerLevelBtm;	// ײ,λ:(V)
	U32 nTriggerSens;		// (Trigger Sensitive for Digital and Analog trigger),λ:΢(uS),ȡֵΧ[0, 1638]
	U32 nDelaySamps;		// ӳٵ, λ:,ȡֵΧ32λЧ[0, 4294967295],0:Post Trigger, >0:Delay Trigger
	U32 nStartTrigOutputEn;	// ʼʹ
	U32 nStartTrigOutputTerm;// ʼ߶ˣָΪRTSI0-7(Ӧֵ0x120~0x127)
	U32 nReserved0;			// ֶ(δ)
} NET8814_AI_START_TRIG, *PNET8814_AI_START_TRIG;

// AIʼṹNET8814_AI_START_TRIGеnTriggerTypeʹõѡ
#define NET8814_AI_START_TRIGTYPE_NONE				0 // ޴(ͬǿƴ)
#define NET8814_AI_START_TRIGTYPE_ANALOG_EDGE		1 // ģش
#define NET8814_AI_START_TRIGTYPE_ANALOG_WIN		2 // ģⴰ
#define NET8814_AI_START_TRIGTYPE_DIGIT_EDGE		3 // ֱش
#define NET8814_AI_START_TRIGTYPE_DIGIT_PATTERN		4 // ģʽ(,δṩ)

// AIʼṹNET8814_AI_START_TRIGеnTriggerDirʹõѡ
// Ϊģشֱشʱ(nTriggerType = TRIGTYPE_ANALOG_EDGE/TRIGTYPE_DIGIT_EDGE):
#define NET8814_AI_START_TRIGDIR_FALLING			0 // ½
#define NET8814_AI_START_TRIGDIR_RISING				1 // 
#define NET8814_AI_START_TRIGDIR_CHANGING			2 // 仯(±ؾЧ)

// Ϊģⴰ(nTriggerType = TRIGTYPE_ANALOG_WIN):
#define NET8814_AI_START_TRIGDIR_EnteringWin		0 // 봰
#define NET8814_AI_START_TRIGDIR_LeavingWin			1 // 
#define NET8814_AI_START_TRIGDIR_LeavingEnterWin	2 // 仯(봰Ч)

typedef struct _NET8814_AI_PAUSE_TRIG // ͣ
{
	U32 nTriggerType;		// , 
	U32 nTriggerSource;		// Դ, ʹģػģⴰʱ: 0=ͨеһ; ʹֱشʱ: 1-9=RTSI0-RTSI8
	U32 nTriggerDir;	    // ִ(Digital Trigger Direction)
	F32 fTriggerLevelTop;	// (ͣƽ),λ:(V)
	F32 fTriggerLevelBtm;	// ײ,λ:(V)
	U32 nTriggerSens;		// (Trigger Sensitive for Digital and Analog trigger),λ:΢(uS),ȡֵΧ[0, 1638]
	U32 nReserved0;			// ֶ(δ)
	U32 nReserved1;			// ֶ(δ)
} NET8814_AI_PAUSE_TRIG, *PNET8814_AI_PAUSE_TRIG;

// AIʼṹNET8814_AI_PAUSE_TRIGеnTriggerTypeʹõѡ
#define NET8814_AI_PAUSE_TRIGTYPE_NONE				0 // ޴(ͣ)
#define NET8814_AI_PAUSE_TRIGTYPE_ANALOG_LVL		1 // ģƽ
#define NET8814_AI_PAUSE_TRIGTYPE_ANALOG_WIN		2 // ģⴰ
#define NET8814_AI_PAUSE_TRIGTYPE_DIGIT_LVL			3 // ֵƽ
#define NET8814_AI_PAUSE_TRIGTYPE_DIGIT_PATTERN		4 // ģʽ(,δṩ)

// AIͣṹNET8814_AI_PAUSE_TRIGеnTriggerDirʹõѡ
// Ϊģƽֵƽʱ(nTriggerType = TRIGTYPE_ANALOG_LVL/TRIGTYPE_DIGIT_LVL):
#define NET8814_AI_PAUSE_TRIGDIR_LOW_LEVEL			0 // ͵ƽ
#define NET8814_AI_PAUSE_TRIGDIR_HIGH_LEVEL			1 // ߵƽ

// Ϊģⴰ(nTriggerType = TRIGTYPE_ANALOG_WIN):
#define NET8814_AI_PAUSE_TRIGDIR_InsideWin			0 // 
#define NET8814_AI_PAUSE_TRIGDIR_OutsideWin			1 // 

// AIʼṹNET8814_AI_START_TRIGеnTriggerSourceԴʹõѡ
#define NET8814_AI_TRIGSRC_AI0				0 // ģⴥԴAI0(nTriggerTypeΪģⴥʱЧ)
#define NET8814_AI_TRIGSRC_AI1				1 // ģⴥԴAI1(nTriggerTypeΪģⴥʱЧ)
#define NET8814_AI_TRIGSRC_AI2				2 // ģⴥԴAI2(nTriggerTypeΪģⴥʱЧ)
#define NET8814_AI_TRIGSRC_AI3				3 // ģⴥԴAI3(nTriggerTypeΪģⴥʱЧ)
#define NET8814_AI_TRIGSRC_AI4				4 // ģⴥԴAI4(nTriggerTypeΪģⴥʱЧ)
#define NET8814_AI_TRIGSRC_AI5				5 // ģⴥԴAI5(nTriggerTypeΪģⴥʱЧ)
#define NET8814_AI_TRIGSRC_AI6				6 // ģⴥԴAI6(nTriggerTypeΪģⴥʱЧ)
#define NET8814_AI_TRIGSRC_AI7				7 // ģⴥԴAI7(nTriggerTypeΪģⴥʱЧ)

#define NET8814_AI_TRIGSRC_DTR				0 // ִԴDTR(nTriggerTypeΪִʱЧ)


typedef struct _NET8814_AI_PARAM // AIйصӲ(AI)
{
	// ͨ
	U32 nSampChanCount;     // ͨ[1, 8](˲ֻ,AI_InitTask()иCHParamеbChannelEnֵͳʵʲͨͨظûʹ)
	U32 nSampleSignal;		// ź(Sample Signal), 泣
	U32 nReserved0;			// ֶ(δ)
	U32 nReserved1;			// ֶ(δ)
	NET8814_AI_CH_PARAM CHParam[NET8814_AI_MAX_CHANNELS]; // ͨ
	
	// ʱӲ
	U32 nSampleMode;		// ģʽ, 0=(), 1Ӳʱ(ݲ֧),2=޵, 3=
	U32 nSampsPerChan;		// ÿͨ(Ҳÿͨȡ),ȡֵΧΪģʽʱӦ1,޵ʱΪ[2, 1024*1024]
	F64 fSampleRate;		// (Sample Rate), λΪsps,ȡֵΧΪ[2000sps, 204800sps],ÿͨĲʡ
	U32 nRefClkSource;		// οʱźѡ, 泣
	U32 nSampClkTimeBase;	// ʱʱѡ,泣
	U32 nSampClkTimeBaseOutEn;			// ʱʱʹ
	U32 nReserved2;			// ֶ(δ)

	NET8814_AI_START_TRIG StartTrig; // ʼ
	NET8814_AI_PAUSE_TRIG PauseTrig; // ͣ

	// 
	U32 nSyncPulseOutputEn;	// ͬʹ
	U32 nSyncPulseSrc;		// ͬ߶ˣΪ0ʾͬ幦ܡʱָΪRTSI0-7
	F64 fSyncPulseWidth;	// ͬ,λ[0~107.374]
	U32 nReserved3;			// ֶ(δ)
	U32 nReserved4;			// ֶ(δ)
} NET8814_AI_PARAM, *PNET8814_AI_PARAM;

// AIӲṹNET8814_AI_PARAMеnSampleSignalźʹõѡ
#define NET8814_AI_SAMPSIGNAL_AI			0 // AIͨź
#define NET8814_AI_SAMPSIGNAL_0V			1 // 0V(AGND)
#define NET8814_AI_SAMPSIGNAL_4D096V		2 // 4.096V
#define NET8814_AI_SAMPSIGNAL_N4D096V		3 // -4.096V
#define NET8814_AI_SAMPSIGNAL_2D048V		4 // 2.048V
#define NET8814_AI_SAMPSIGNAL_N2D048V		5 // -2.048V
#define NET8814_AI_SAMPSIGNAL_0D819V		6 // 0.819V
#define NET8814_AI_SAMPSIGNAL_N0D819V		7 // -0.819V

// AIӲṹNET8814_AI_PARAMеnRefClkSourceοʱźѡ
#define NET8814_REFCLK_LOCAL				0 // زοʱ
#define NET8814_RTSI_10M					0x0129 // ͨRTSIߵRTSI_10M߶οʱ

// AIӲṹNET8814_AI_PARAMеnSampClkTimeBaseʱʱźѡ
#define NET8814_SAMPCLK_TIMEBASE_LOCAL		0 // ʱ
#define NET8814_RTSI8						0x0128 // RTSI8

// ź߶˶(RTSI߶)
#define NET8814_NONE						0x0000 // NONE
#define NET8814_RTSI0						0x0120 // RTSI0
#define NET8814_RTSI1						0x0121 // RTSI1
#define NET8814_RTSI2						0x0122 // RTSI2
#define NET8814_RTSI3						0x0123 // RTSI3
#define NET8814_RTSI4						0x0124 // RTSI4
#define NET8814_RTSI5						0x0125 // RTSI5
#define NET8814_RTSI6						0x0126 // RTSI6
#define NET8814_RTSI7						0x0127 // RTSI7

// AIӲṹNET8814_AI_PARAMеnSampleModeģʽʹõѡ
#define NET8814_AI_SAMPMODE_ONE_DEMAND		0 // 赥
#define NET8814_AI_SAMPMODE_FINITE			2 // ޵
#define NET8814_AI_SAMPMODE_CONTINUOUS		3 // 

// AIӲṹNET8814_AI_PARAMеnDTriggerDir/nATriggerDirʹõѡ
#define NET8814_AI_TRIGDIR_FALLING			0 // ½/͵ƽ/봰
#define NET8814_AI_TRIGDIR_RISING			1 // /ߵƽ/
#define NET8814_AI_TRIGDIR_CHANGING			2 // 仯(±/ߵ͵ƽЧ)

// #################### AI״̬ṹNET8814_AI_STATUS #####################
typedef struct _NET8814_AI_STATUS
{
	U32 bTaskDone;				// ɼɱ־, =TRUE:ʾɼ, =FALSE:ʾɼδ,ڽ
	U32 bTriggered;				// ־, =TRUE:ʾѱ, =FALSE:ʾδ(ȴ)

	U32 nTaskState;				// ɼ״̬, =1:, ֵʾ쳣
	U32 nAvailSampsPerChan;		// ÿͨЧ,ֻڵǰָʱܵAI_ReadAnalog()ȡָȵĲ
	U32 nMaxAvailSampsPerChan;	// AI_StartTask()ÿֹͨЧ,״ֵ̬Χ[0, nBufSampsPerChan],Ϊɼܶṩ,ֵԽ1,ʾζԽ,Խ׳Ŀ
	U32 nBufSampsPerChan;		// ÿͨС()
	I64 nSampsPerChanAcquired;	// ÿͨѲ(ԿʼɼAI_StartTask()֮ĵ),ֻǸûͳ

	U32 nHardOverflowCnt;		// Ӳ(ڲº0)
	U32 nSoftOverflowCnt;		// (ڲº0)
	U32 nInitTaskCnt;			// ʼɼĴ(AI_InitTask()Ĵ)
	U32 nReleaseTaskCnt;		// ͷŲɼĴ(AI_ReleaseTask()Ĵ)
	U32 nStartTaskCnt;			// ʼɼĴ(AI_StartTask()Ĵ)
	U32 nStopTaskCnt;			// ֹͣɼĴ(AI_StopTask()Ĵ)
	U32 nTransRate;				// , ÿ봫(sps),ΪUSBӦܵļϢ

	U32 nReserved0;				// ֶ(δ)
	U32 nReserved1;				// ֶ(δ)
	U32 nReserved2;				// ֶ(δ)
	U32 nReserved3;				// ֶ(δ)
	U32 nReserved4;				// ֶ(δ)
} NET8814_AI_STATUS, *PNET8814_AI_STATUS;

// #################### AIҪϢṹ(NET8814_AI_MAIN_INFO) #######################
typedef struct _NET8814_AI_MAIN_INFO
{
	U32 nChannelCount;		// AIͨ
	U32 nSampRangeCount;	// AIΧλ
	U32 nSampGainCount;		// AI浲λ
	U32 nCouplingCount;		// AIϵλ
	U32 nImpedanceCount;	// AI迹ĵλ
	U32 nDepthOfMemory;		// AIش洢()
	U32 nSampResolution;	// AIֱ(=8ʾ8Bit; =12ʾ12Bit; =14ʾ14Bit; =16ʾ16Bit)
	U32 nSampCodeCount;		// AI(256, 4096, 16384, 65536)
	U32 nTrigLvlResolution;	// ƽֱ(=8ʾ8Bit; =12ʾ12Bit; =16ʾ16Bit)
	U32 nTrigLvlCodeCount;	// ƽ(256, 4096)

	U32 nReserved0;			// ֶ(δ)
	U32 nReserved1;			// ֶ(δ)
	U32 nReserved2;			// ֶ(δ)
	U32 nReserved3;			// ֶ(δ)
} NET8814_AI_MAIN_INFO, *PNET8814_AI_MAIN_INFO;

// #################### AIΧϢṹ(NET8814_AI_VOLT_RANGE_INFO) #######################
typedef struct _NET8814_AI_VOLT_RANGE_INFO
{
	U32 nSampleRange;		// ǰΧλ
	U32 nReserved0;			// ֶ(δ)
	F64 fMaxVolt;			// Χѹֵ,λ:(V)
	F64 fMinVolt;			// ΧСѹֵ,λ:(V)
	F64 fAmplitude;			// Χ,λ:(V)
	F64 fHalfOfAmp;			// ΧȵĶ֮һ,λ:(V)
	F64 fCodeWidth;			// ,λ:(V), ÿλֵĵѹֵ
	F64 fOffsetVolt;		// ƫƵѹ,λ:(V),һƫУ׼
	F64 fOffsetCode;		// ƫֵ,һƫУ׼,ĵѹֵȼfOffsetVolt
	char strDesc[16];		// Χַ,"10V", L"0-10V"

	U32 nPolarity;			// Χļ(0=˫BiPolar, 1=UniPolar)
	U32 nCodeCount;			// ԭ
	I32 nMaxCode;			// ԭֵ
	I32 nMinCode;	        // ԭСֵ

	U32 nReserved1;			// ֶ(δ)
	U32 nReserved2;			// ֶ(δ)
	U32 nReserved3;			// ֶ(δ)
	U32 nReserved4;			// ֶ(δ)
} NET8814_AI_VOLT_RANGE_INFO, *PNET8814_AI_VOLT_RANGE_INFO;

// ṹAI_VOLT_RANGE_INFOݳԱPolarityõĲΧѡ
#define NET8814_AI_POLAR_BIPOLAR	0 // ˫
#define NET8814_AI_POLAR_UNIPOLAR	1 // 

// #################### AIϢṹ(NET8814_AI_SAMP_RATE_INFO) #######################
typedef struct _NET8814_AI_SAMP_RATE_INFO
{
	F64 fMaxRate;		// ͨ(sps)
	F64 fMinRate;		// ͨС(sps)
	F64 fTimerBase;		// ʱӻ׼ؾƵʣλ:Hz
	U32 nDivideMode;	// Ƶģʽ,0=Ƶ(INTDIV), 1=DDSƵ(DDSDIV)
	U32 nRateType;		// ,ָfMaxRatefMinRate, =0:ʾΪвͨ, =1:ʾΪÿͨ

	U32 nReserved0;		// ֶ(δ)
	U32 nReserved1;		// ֶ(δ)
} NET8814_AI_SAMP_RATE_INFO, *PNET8814_AI_SAMP_RATE_INFO;

// #################### AIAODIDOCICOõĲ #######################
// AI_ReadAnalog()/AI_ReadBinary()AO_WriteAnalog()/AO_WriteBinary()DI_ReadDigitalLines()/DO_WriteDigitalLines()ĲnFillModeʹõ䷽ʽѡ
#define NET8814_FILLMODE_GroupByScanNumber		0 // ɨŷ仺()
#define NET8814_FILLMODE_GroupByChannel			1 // ͨ仺()

// NET8814_DEV_CreateA()ĲnLinkType(豸ӷʽ)ʹõѡ
#define NET8814_LINKTYPE_TCP		0 // TCP
#define NET8814_LINKTYPE_UDP		1 // UDP

// ################################ Ϣ ################################
#define ERROR_NO_AVAILABLE_SAMPS	(0xE0000000+1)	// Ч
#define ERROR_TASK_FAIL				(0xE0000000+2)	// ʧ
#define ERROR_RATE_OVER_RANGE		(0xE0000000+3)	// ʳ
#define ERROR_TASK_STOP				(0xE0000000+4)	// ֹ

// ################################ 豸ӿ ################################
#ifndef _NET8814_DRIVER_
#define DEVLIB __declspec(dllimport)
#else
#define DEVLIB __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################  DEV豸  ################################

	HANDLE DEVLIB WINAPI NET8814_DEV_CreateA(
									LPCSTR strIPAddr,			// IPַ(charַ)
									LONG   nLinkType = 0,			// 0:TCP 1:UDP()
									LONG   nSendTimeout = 200,	// ͳʱʱ
									LONG   nRecvTimeout = 200);	// ճʱʱ

	HANDLE DEVLIB WINAPI NET8814_DEV_CreateW(
									LPCWSTR strIPAddr,			// IPַ(WCHARַ)
									LONG   nLinkType = 0,			// 0:TCP 1:UDP
									LONG   nSendTimeout = 200,	// ͳʱʱ
									LONG   nRecvTimeout = 200);	// ճʱʱ

	BOOL DEVLIB WINAPI NET8814_DEV_Release(HANDLE hDevice);	// ͷ豸(ؼ)

#ifndef _UNICODE
#define NET8814_DEV_Create	NET8814_DEV_CreateA
#else
#define NET8814_DEV_Create	NET8814_DEV_CreateW
#endif


	BOOL DEVLIB	FAR	PASCAL NET8814_DEV_Release(				// ͷ豸
									HANDLE hDevice);			// 豸
    
	BOOL DEVLIB WINAPI NET8814_GetNetCfgA(					// 豸̫ò
									HANDLE hDevice,				// 豸
									PDEVICE_NET_INFOA pNetInfo);// ṹ

	BOOL DEVLIB WINAPI NET8814_GetNetCfgW(						// 豸̫ò
									HANDLE hDevice,				// 豸
									PDEVICE_NET_INFOW pNetInfo);// ṹ

#ifndef _UNICODE
#define NET8814_GetNetCfg	NET8814_GetNetCfgA
#else
#define NET8814_GetNetCfg	NET8814_GetNetCfgW
#endif

	BOOL DEVLIB WINAPI NET8814_SetNetCfgA(					// ̫
									HANDLE hDevice, 			// 豸
									PDEVICE_NET_INFOA pNetInfo);// ṹ

	BOOL DEVLIB WINAPI NET8814_SetNetCfgW(						// ̫
									HANDLE hDevice, 			// 豸
									PDEVICE_NET_INFOW pNetInfo);// ṹ

#ifndef _UNICODE
#define NET8814_SetNetCfg	NET8814_SetNetCfgA
#else
#define NET8814_SetNetCfg	NET8814_SetNetCfgW
#endif

	// ################################ AIģʵֺ ################################
	BOOL DEVLIB WINAPI NET8814_AI_InitTask(					// ʼɼ(Initialize Task)
									HANDLE hDevice,			// 豸,DEV_Create()
									PNET8814_AI_PARAM pAIParam, // AI, ڴ˺оӲʼ״̬͸ģʽ,AI_VerifyParam()вУ
									HANDLE* pSampEvent);	// ز¼,豸гֿɶݶʱᴥ¼,=NULL,ʾҪ¼

	BOOL DEVLIB WINAPI NET8814_AI_StartTask(				// ʼɼ
									HANDLE hDevice);		// 豸,DEV_Create()

    BOOL DEVLIB WINAPI NET8814_AI_SendSoftTrig(				// ¼(Send Software Trigger),Ҳǿƴ
									HANDLE hDevice);		// 豸,DEV_Create()

	BOOL DEVLIB WINAPI NET8814_AI_GetStatus(				// ȡAI״̬
									HANDLE hDevice,			// 豸,DEV_Create()
									PNET8814_AI_STATUS pAIStatus);// ȡAI״̬

	BOOL DEVLIB WINAPI NET8814_AI_WaitUntilTaskDone(		// ɼǰȴ,TRUEʾɼ
									HANDLE hDevice,			// 豸,DEV_Create()
									F64 fTimeout);			// ڵȴʱ,λ:(S)

	BOOL DEVLIB WINAPI NET8814_AI_ReadAnalog(				// Ӳɼжȡ(ѹ)(Read analog data from the task)
									HANDLE hDevice,			// 豸,DEV_Create()
									F64 fAnlgArray[],		// ģ(ѹ),ڷزĵѹ,ȡֵɸͨʱĲΧ(λ:V)
									U32 nReadSampsPerChan,	// ÿͨȡĵ(λ:)
									U32* pSampsPerChanRead,	// ÿͨʵʶȡĵ(λ:), =NULL,ʾ뷵
									F64 fTimeout,			// ʱʱ,λ:(S)
									U32 nFillMode);			// ䷽ʽ, 0=GroupByScanNumber(ɨͨŷ,), 1=GroupByChannel(ͨ,)

	BOOL DEVLIB WINAPI NET8814_AI_ReadBinary(				// Ӳɼжȡ(ԭ)(Read binary data from the task)
									HANDLE hDevice,			// 豸,DEV_Create()
									I32 nBinArray[],		// 飨ԭ飩,ڷزԭ,ȡֵΪ[-8388608, 8388607]
									U32 nReadSampsPerChan,	// ÿͨȡĵ(λ:)
									U32* pSampsPerChanRead,	// ÿͨʵʶȡĵ(λ:), =NULL,ʾ뷵
									F64 fTimeout,			// ʱʱ,λ:(S)
									U32 nFillMode);			// ䷽ʽ, 0=GroupByScanNumber(ɨͨŷ,), 1=GroupByChannel(ͨ,)

	BOOL DEVLIB WINAPI NET8814_AI_StopTask(HANDLE hDevice);	// ֹͣAIɼ

	BOOL DEVLIB WINAPI NET8814_AI_ReleaseTask(HANDLE hDevice); // ͷŲɼ

	// ========================= AI =========================
	BOOL DEVLIB WINAPI NET8814_AI_GetMainInfo(				// AIҪϢ
									HANDLE hDevice,			// 豸,DEV_Create()
									PNET8814_AI_MAIN_INFO pMainInfo); // AIҪϢ

	BOOL DEVLIB WINAPI NET8814_AI_GetVoltRangeInfo(			// òΧĸϢ(ȡֱʡ)
									HANDLE hDevice,			// 豸,DEV_Create()
									U32 nChannel,			// AIͨ[0, 7]
									U32 nSampleRange,		// Χѡ[0, 7]
									double fSampleRate,		// ,λ:sps
									PNET8814_AI_VOLT_RANGE_INFO pRangeInfo); // ΧϢ

	BOOL DEVLIB WINAPI NET8814_AI_GetRateInfo(				// òϢ
									HANDLE hDevice,			// 豸,DEV_Create()
									PNET8814_AI_SAMP_RATE_INFO pRateInfo); // Ϣ

	BOOL DEVLIB WINAPI NET8814_AI_ScaleBinToVolt(			// ָΧԭɵѹ,ʵĵ
									PNET8814_AI_VOLT_RANGE_INFO pRangeInfo, // ǰתҪĲΧϢ
									PVOID pGainInfo,		// ǰתҪĲϢ(=NULL,ʾʹ)
									F64 fVoltArray[],		// ѹ,ڷĵѹ,λV
									I32 nBinArray[],		// ԭ,ڴǰԭ,ȡֵΪ[-8388608, 8388607], (ָĳͨ)
									U32 nScaleSamps,		// Ĳ
									U32* pSampsScaled);		// ʵĲ, =NULL,ʾ뷵

	BOOL DEVLIB WINAPI NET8814_AI_ScaleVoltToBin(			// ָΧѹɶԭ,ʵĵ
									PNET8814_AI_VOLT_RANGE_INFO pRangeInfo, // ǰתҪĲΧϢ
									PVOID pGainInfo,		// ǰתҪĲϢ(=NULL,ʾʹ)
									I32 nBinArray[],		// ԭ뻺,ڷԭ,ȡֵΪ[-8388608, 8388607], (ָĳͨ)
									F64 fVoltArray[],		// ѹ,ڴǰĵѹ,λV
									U32 nScaleSamps,		// Ĳ
									U32* pSampsScaled);		// ʵĲ, =NULL,ʾ뷵

	BOOL DEVLIB WINAPI NET8814_AI_VerifyParam(				// УAI(Verify Parameter),ڳʼAIǰô˺УϷ
									HANDLE hDevice,			// 豸,DEV_Create()
									PNET8814_AI_PARAM pAIParam);// УAI

	BOOL DEVLIB WINAPI NET8814_AI_LoadParam(HANDLE hDevice, PNET8814_AI_PARAM pAIParam); // NET8814.iniмAI
	BOOL DEVLIB WINAPI NET8814_AI_SaveParam(HANDLE hDevice, PNET8814_AI_PARAM pAIParam); // AINET8814.ini
	BOOL DEVLIB WINAPI NET8814_AI_ResetParam(HANDLE hDevice, PNET8814_AI_PARAM pAIParam); // ǰAIλֵ

#ifdef __cplusplus
}
#endif

#ifndef _CVIDEF_H
	// Զ
	#ifndef _NET8814_DRIVER_
		#ifndef LOAD_NET8814_LIB // ûмLIB
			#define LOAD_NET8814_LIB
				#ifndef _WIN64
					#pragma comment(lib, "NET8814.lib")
					#pragma message("======== Welcome to use our art company's products!")
					#pragma message("======== Automatically linking with NET8814.dll...")
					#pragma message("======== Successfully linked with NET8814.dll")
				#else
					#pragma comment(lib, "NET8814_64.lib")
					#pragma message("======== Welcome to use our art company's products!")
					#pragma message("======== Automatically linking with NET8814_64.dll...")
					#pragma message("======== Successfully linked with NET8814_64.dll")
				#endif
		#endif // LOAD_NET8814_LIB
	#endif // _NET8814_DRIVER_
#endif // _CVIDEF_H

#endif // _NET8814_DEVICE_